<template>
  <b-list-group-item :variant="favorited ? favoriteVariant : ''">
    <div class="locus-summary">
      <div class="body">
        <div>
          <h5 class="header">
            <b-link
              :to="{ name: 'locusDetail', params: { locusId: locus.id } }"
              class="mr-2"
              variant="link"
            >
              {{ locus.properties.ztf_object_id }}
            </b-link>
            <small>
              <coordinates-formatter-icrs
                class="text-muted"
                :dec="locus.dec"
                :ra="locus.ra"
              />
            </small>
          </h5>
          <div class="subheader">
            <p
              v-if="comment && !editingComment"
              class="text-muted mb-2"
              @click="edit"
            >
              {{ comment }}
            </p>
            <b-input
              v-if="editingComment"
              ref="commentInput"
              :disabled="submittingComment"
              :value="comment"
              class="mr-4"
              placeholder="Enter a comment for this locus"
              size="sm"
              @change="updateComment"
            />
          </div>
          <div class="locus-statistics">
            <div>
              <div>Num. Measurements: {{ locus.properties.num_mag_values }}</div>
            </div>
          </div>
        </div>
      </div>
      <div>
        <locus-actions
          :console="false"
          :download="false"
          :email="false"
          :locus="locus"
          :permalink="false"
          @commenting="edit"
          @favorited="$emit('favorited')"
          @unfavorited="$emit('unfavorited')"
        />
      </div>
    </div>
  </b-list-group-item>
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue';
import { mapGetters } from 'vuex';
import { julian } from 'astronomia';

import { Locus, LocusAnnotation } from '@/common/types';
import { CREATE_OR_UPDATE_LOCUS_ANNOTATION, FETCH_USER_DATA } from '@/store/actions';
import CoordinatesFormatterIcrs from '@/components/CoordinatesFormatterIcrs.vue';
import LocusActions from './LocusActions.vue';

export default Vue.extend({
  components: {
    CoordinatesFormatterIcrs,
    LocusActions,
  },

  props: {
    favoriteVariant: {
      type: String,
      default: '',
    },

    locus: {
      type: Object,
      required: true,
    } as PropOptions<Locus>,
  },

  data() {
    return {
      editingComment: false,
      submittingComment: false,
    };
  },

  computed: {
    ...mapGetters(['user', 'userData']),
    annotation(): LocusAnnotation | null {
      return this.userData.locusAnnotations[this.locus.id] || null;
    },
    comment(): string {
      return this.annotation ? this.annotation.comment : '';
    },
    favorited(): boolean {
      return this.annotation ? this.annotation.favorited : false;
    },
    newestObservationTime(): string {
      return julian
        .JDToDate(julian.JDToMJD(this.locus.properties.newest_alert_observation_time))
        .toUTCString();
    },
    oldestObservationTime(): string {
      return julian
        .JDToDate(julian.JDToMJD(this.locus.properties.oldest_alert_observation_time))
        .toUTCString();
    },
  },

  methods: {
    edit() {
      this.editingComment = true;
      this.$nextTick(() => (<any> this.$refs.commentInput).$el.focus());
    },
    async updateComment(comment: string) {
      this.submittingComment = true;
      try {
        await this.$store.dispatch(CREATE_OR_UPDATE_LOCUS_ANNOTATION, {
          locusId: this.locus.id,
          locusAnnotation: { comment },
        });
        await this.$store.dispatch(FETCH_USER_DATA, { identity: this.user.id });
      } finally {
        this.submittingComment = false;
        this.editingComment = false;
      }
    },
  },
});
</script>

<style lang="scss" scoped>
.underlined {
  text-decoration: underline;
}
.locus-summary {
  display: flex;
}
.body {
  flex: 1;
  display: flex;
  flex-direction: column;
}
.header-row {
  display: flex;
  justify-content: space-between;
  align-items: flex-start;
  margin: 0;
}
.header {
  display: flex;
  align-items: center;
  margin-bottom: 0em;
}
.locus-statistics {
  display: flex;
  margin: 0 -10px;
}
.locus-statistics > div {
  margin: 0 10px;
}
</style>
